
import java.io.File;
import java.io.FileNotFoundException;
import java.util.Observable;
import java.util.Scanner;

import javax.swing.plaf.basic.BasicTabbedPaneUI.TabbedPaneLayout;

import javafx.application.Application;
import javafx.collections.ObservableList;
import javafx.geometry.Insets;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.scene.control.cell.PropertyValueFactory;
import javafx.scene.layout.Background;
import javafx.scene.layout.BackgroundFill;
import javafx.scene.layout.CornerRadii;
import javafx.scene.layout.HBox;
import javafx.scene.layout.VBox;
import javafx.scene.paint.Color;
import javafx.stage.Stage;
import javafx.stage.Window;

public class Driver  extends Application {
	
	TableView<Table> table = new TableView<>();

	
	static CursorStack<Expression> equation =new CursorStack<>();
	static int l=equation.createList();	
	
	public void start(Stage ps) {
	//	CursorLinkedList<Integer> cursorLinkedList=new CursorLinkedList<>();
	//	cursorLinkedList.initialization();
	
		
		
		
		
		VBox pane = new VBox();
		
		HBox hButton = new HBox();
		hButton.setPadding(new Insets(20, 20, 20, 120));
		hButton.setSpacing(30);
		Button loadBut = new Button("Load from File");
		//Button displayBut = new Button("Display");
		Button writeBut = new Button("Write to another File");
		loadBut.setPrefWidth(130);
		//displayBut.setPrefWidth(100);
		writeBut.setPrefWidth(130);
		hButton.getChildren().addAll(loadBut, writeBut);

		
		
		
		
		
		
		VBox vTable = new VBox();

		TableColumn<Table, String> infix = new TableColumn<>("Infix");
		infix.setCellValueFactory(new PropertyValueFactory<>("infix"));
		infix.setPrefWidth(160);
		
		TableColumn <Table,Boolean> validity = new TableColumn<>("Validity");
		validity.setCellValueFactory(new PropertyValueFactory<>("validity"));
		
		
		TableColumn <Table,String> postfix = new TableColumn<>("postfix");
		postfix.setCellValueFactory(new PropertyValueFactory<>("postfix"));
		postfix.setPrefWidth(200);
		
		
		TableColumn <Table,Double> evaluating = new TableColumn<>("Evaluating");
		evaluating.setCellValueFactory(new PropertyValueFactory<>("Evaluating"));
		
		table.getColumns().addAll(infix, validity, postfix,evaluating);
		table.setPrefHeight(320);
		//table.setItems(getTable());
		
		
		
		
		
		
//		
//		Button delete=new Button("Delete");
//		delete.setPrefWidth(520);
//		
		
		Label process=new Label("Process :  ");

		Label note=new Label("");
		HBox notePros=new HBox();
		notePros.getChildren().addAll(process,note);
		
	Button exitButt=new Button("Exit");
	exitButt.setPrefWidth(520);
		
		vTable.setSpacing(20);
		vTable.getChildren().addAll(table,notePros,exitButt);

		vTable.setPadding(new Insets(0, 10, 0, 10));
		
		
		
		
		
		
		
		pane.getChildren().addAll(hButton, vTable);
		pane.setBackground(new Background(new BackgroundFill(Color.BURLYWOOD,CornerRadii.EMPTY,Insets.EMPTY)));

		Scene scene = new Scene(pane, 520, 500);

		ps.setScene(scene);
		ps.setResizable(false);
		ps.setTitle("Project#2");
		ps.show();
		
		loadBut.setOnAction(e->{
			
			
			try {
				loadedFile() ;
				if(!(equation.isEmpty(l))){
					note.setText("loded have been successfully");
					note.setTextFill(Color.GREEN);	
					
					
					loadBut.setDisable(true);		
					//table.setItems(getTable());	
				}
				else{
					note.setText("There are no equations. Make sure the file ");
					note.setTextFill(Color.RED);
				}
						
				
				
			} catch (Exception e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
//			FileChooser fileChooser = new FileChooser();
//			fileChooser.setTitle("Open Resource File");
//			Window stage = null;
//			fileChooser.showOpenDialog(stage);
			
			
		
			
		});
		
		
		
		
		writeBut.setOnAction(e->{
			
			
			try {
				
				if(!(equation.isEmpty(l))){
				equation.writeToFile(l);
				note.setText("Copies have been successfully");
				note.setTextFill(Color.GREEN);	
				writeBut.setDisable(true);
				
				
				}
				
				else
				{note.setText("There are no equations, you can download a file containing the equations");
					note.setTextFill(Color.RED);
				}
			} catch (Exception e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			
			
			
		});
		
	
//		delete.setOnAction(e->{
//			
//			ObservableList<Table> selectedItems,allItems;
//			allItems=table.getItems();
//			selectedItems=table.getSelectionModel().getSelectedItems();
//			//System.out.println(allItems);
//		//	System.out.println(selectedItems);
//			
//			selectedItems.forEach(allItems::remove);
//			
//		});
		exitButt.setOnAction(e->{
			ps.close();
		});
		
		
		

	}

	public static void main(String[] args) {
		
	launch(args);

	}
	
	
	public void loadedFile() throws FileNotFoundException{
		
		File file = new File("file.txt");
		if (file.exists()) {
			Scanner input = new Scanner(file);
			// Read data from a file
			while (input.hasNextLine()) {
				
				String line = input.nextLine();
				Expression<String> equationTruth=new Expression<>(line);
				
				//add equation to tableView
				Table tab=new Table(line, equationTruth.isVaild(), equationTruth.getPostfix(), equationTruth.getEvaluate());
				table.getItems().add(tab);
				
			//	add equation to curser
				equation.push(equationTruth, l);
				
			
			}
			//System.out.println(equation.pop(l));
			// Close the file
			input.close();
		}}
	
	
//	public ObservableList<Table> getTable(){
//		ObservableList<Table> tables=FXCollections.observableArrayList();
//		tables.add(new Table("mogfgf",true,"dfsf",(double) 829));
//		tables.add(new Table("mogfghdfgbdf",true,"dfgfdgsf",(double) 965));
//		tables.add(new Table("mogfggfdgdf",false,"dfsgdff",(double) 569));
//		tables.add(new Table("mogfggfdgdf",true,"dfsgdff",(double) 569));
//
//		return tables;
//	}
	
	
	

}