import javax.swing.tree.ExpandVetoException;

public class Expression <T>{

	private String truthdata;
	private String data; //without seter and geter 
	private boolean vaild;
	private String postfix;
	private Double evaluate =null;
	
	
	public Expression(String data){
		
		this.truthdata=data;
		
		if(isBalanced(data)){
		 
		if(data.startsWith("-")||data.startsWith("+")){
			data="0"+data;
		}
		data = "(" +data+ ")"; //case validation
       data = data.replace ("+-", "-");
       data = data.replace("++", "+");
       data = data.replace("-+", "-");
       data = data.replace("--", "+");
       data = data.replace("*-(", "*-1*(");
       data = data.replace("/-(", "/-1/(");
       data = data.replace("(-", "(0-");
       data = data.replace("(+", "(0+");
       

       
	//  data = fixIt(data);
		
			data=this.insertNotation(data);
		try{	
		convertToPostfix(data);
	   this.calculated();
	   this.vaild=true;
	   
	   
		}
		catch(Exception e){
			postfix="invalid input";
			this.vaild=false;
		}

		}
	}

	
	 public String getTruthdata() {
		return truthdata;
	}


	public void setTruthdata(String truthdata) {
		this.truthdata = truthdata;
	}

	public boolean isVaild() {
		return vaild;
	}

	public void setVaild(boolean vaild) {
		this.vaild = vaild;
	}

	public String getPostfix() {
		return postfix;
	}

	public void setPostfix(String postfix) {
		this.postfix = postfix;
	}

	public Double getEvaluate() {
		return evaluate;
	}

	public void setEvaluate(Double evaluate) {
		this.evaluate = evaluate;
	}

	public String fixIt(String data) {
	        boolean ob = false;
	        String fin = "";
	        for (int i = 0; i < data.length(); i++) {
	            if ((data.charAt(i) == '*' || data.charAt(i) == '/') && data.charAt(i + 1) == '-') {

	                fin += data.charAt(i) + "(0";
	                ob = true;

	            } else {
	                if (!ob) {
	                    fin += "" + data.charAt(i);
	                } else {
	                    if (data.charAt(i) == '-') {
	                        fin += "" + data.charAt(i);
	                    } else {
	                        if (isOperator(data.charAt(i))) {
	                            fin += ")" + data.charAt(i);
	                            ob = false;
	                        } else {
	                            fin += "" + data.charAt(i);
	                        }
	                    }
	                }
	            }
	        }
	        return fin;
	    } 
		
	public boolean isBalanced(String truthdata){
		boolean balance = true;
		CursorStack<String> balnceStack =new CursorStack<>();
		int l=balnceStack.createList();
		char[] car = truthdata.toCharArray();
		
		for (int i = 0; i < car.length; i++) {
			if ((car[i] == '('))
				balnceStack.push(car[i]+"".trim(), l);
			else if ((car[i] == ')')) {
				
				if (balnceStack.isEmpty(l)) {
					balance = false;
					break;
				}
				else {
					Node<String> car1 = balnceStack.pop(l);
					if (car1.getData().compareTo("(")==0) {
						if (car[i]!= ')') {
							balance = false;
							break;
						}
					}
					}
				}

			
		}
		if(balnceStack.isEmpty(l))
		return balance;
		return false;
	}
	
	public void calculated(){
		
		String[] str = postfix.split(" ");
		CursorStack<Double> stacktoEvaluateBost = new CursorStack<>();
		int l=stacktoEvaluateBost.createList();
		
		for (int i = 0; i < str.length; i++) {
			if (this.isNum(str[i])) {
				stacktoEvaluateBost.push(Double.parseDouble(str[i]),l);
			} else {
				double operandTwo = stacktoEvaluateBost.pop(l).getData();
				double operandOne = stacktoEvaluateBost.pop(l).getData();
				double result = 0;
				switch (str[i].charAt(0)) {
				case '+':
					result = operandOne + operandTwo;
					break;
				case '-':
					result = operandOne - operandTwo;
					break;
				case '*':
					result = operandOne * operandTwo;
					break;
				case '/':
					result = operandOne / operandTwo;
					break;
				case '^':
					result = (int) Math.pow(operandOne, operandTwo);
					break;
				}
				stacktoEvaluateBost.push(result,l);
			}
			}
		this.evaluate= stacktoEvaluateBost.pop(l).getData();

		
		
		
		
		
	}
		
    public Double evaluate() {
		return evaluate;
    	
    }

	public boolean isNum(String num) {
		try {
			Double.parseDouble(num);
			return true;
		} catch (Exception e) {
			return false;
		}

	}
    	
	////////////////////////////////////////////////////////////////////////////////
    public int getProc(Character x) {
        int proc = 0;
        switch (x) {//simple case check for passed character
            //set precedence level
            case '^':
                proc = 3;
                break;
            case '*':
            case '/':
                proc = 2;
                break;
            case '+':
            case '-':
                proc = 1;
                break;

        }
        return proc;//return level of precedence
    }
	
	public  void convertToPostfix(String infix)
    {
		CursorStack<String> stack = new CursorStack<>();
		int l=stack.createList();
		
        StringBuffer postfix = new StringBuffer(infix.length());
        String[] pos =infix.split("#");
        
        
        String c;
     

        for (int i = 0; i < pos.length; i++)
        {
            c = pos[i];
            if(!c.trim().equals("")){
            if (isNum(c))
            {
                postfix.append(c+" ");
            }

            else
            {
                if (c.compareTo(")")==0)
                {

                    while (!stack.isEmpty(l) && !(stack.getFirst(l).equals("(")))
                    {
                        postfix.append(stack.pop(l)+" ");
                    }
                    if (!stack.isEmpty(l))
                    {
                        stack.pop(l);
                    }
                }

                else
                {
                    if (!stack.isEmpty(l) && getProc(c.trim().charAt(0))>getProc( stack.getFirst(l).trim().charAt(0)))
                    {
                        stack.push(c,l);
                    }
                    else
                    {
                        while (!stack.isEmpty(l) && getProc(c.trim().charAt(0))<getProc( stack.getFirst(l).trim().charAt(0)))
                        {
                            String pop = stack.pop(l).getData();
                            if (!c.equals("("))
                            {
                                postfix.append(pop+" ");
                            } else {
                              c = pop;
                            }
                        }
                        stack.push(c,l);
                    }

                }
            }
        }}
        while (!stack.isEmpty(l)) {
          postfix.append(stack.pop(l));
        }

        //replace all tow indentation by one indintation 
       this.postfix= (postfix+"").replace("  ", " ");
    }
	
	////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
	public boolean isOperator(char x) {
		return (x == '^' || x == ')' || x == '(' || x == '/' || x == '*' || x == '-' || x == '+');
	}

	// method to check if operator (String)
	private boolean isOperatorStr(String x) {
		return (x.equals("^") || x.equals("(") || x.equals(")") || x.equals("-") || x.equals("+") || x.equals("*")
				|| x.equals("/"));
	}
	
	public String toString(){
		return "[Equation ="+truthdata+ " || vaild=" + vaild + " || postfix=" + postfix + 
				" || evaluate="+ evaluate + "]";
	}
	
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    

	
	public String insertNotation(String data){
	
		char[] x= data.toCharArray();
		String handelStr="";
		
		for (int i = 0; i < data.length(); i++) {
			if (this.isOperator(x[i]))
				handelStr=handelStr+"#"+x[i]+"#";
			else
				handelStr+=x[i];
			
		}
		
		//System.out.println(handelStr);
		return handelStr;
	}
}


